#include "delay.h"
#include "gpio.h"
#include "can.h"
#include "can_demo.h"

void Led_Init(void)
{
    GPIO_InitTypeDef	GPIO_InitStruct = {0};
	
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);
	
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_LOW;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);
}

int main(void)
{
	uint8_t i = 0;
	uint32_t msCnt;     // count value of 1ms
	CanTxRxMsg CAN_SendMsg;
	extern CanTxRxMsg CAN_RecvMsg;
	
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);
	
	Led_Init();
	
	CAN_Port_Config();
	
	CAN_SendMsg.Id = 0x731;
	CAN_SendMsg.IDE = CAN_Id_Standard;
	CAN_SendMsg.CacheType = CAN_CacheType_Tx;
	CAN_SendMsg.RTR = CAN_RTR_Data;
	CAN_SendMsg.DLC = 8;
	CAN_SendMsg.Data[7] = 0x9F;
	CAN_MessageCache_DeInit(CAN0MSG01);
	CAN_MessageCache_Init(CAN0MSG01, &CAN_SendMsg);
	
	CAN_RecvMsg.Id = 0x231;
	CAN_RecvMsg.IDE = CAN_Id_Standard;
	CAN_RecvMsg.CacheType = CAN_CacheType_Rx_1Mask;
	CAN_RecvMsg.RTR = CAN_RTR_Data;
	CAN_RecvMsg.Interrupt = ENABLE;
	CAN_MessageCache_DeInit(CAN0MSG07);
	CAN_MessageCache_Init(CAN0MSG07, &CAN_RecvMsg);
	CAN_MessageCache_OverWriteConfig(CAN0MSG07, ENABLE);
	
	while(1)
	{
		PORT->P7 ^= (1<<1);
		PORT->P7 ^= (1<<2);
		
		CAN_SendMsg.Data[0] += 3;
		CAN_Transmit(CAN0MSG01, &CAN_SendMsg);
		
		m0_delay_ms(250);
	}
	
	return 0;
}

