/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32G139
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "tima_demo.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern volatile uint16_t g_tma0_ta0_value;   /* TA0 = 65535 */
extern volatile uint16_t g_tma0_underflow_count ;


int main()
{
	uint32_t msCnt; 	// count value of 1ms
	uint32_t width;
//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 
	
	Uart0_Init(19200);

#if 0
	/*ʵʱߵƽ*/
	TMA_Get_PulseWidth(TMA_FCLK_Div1, TMA_Pulse_Width_High);
    TMA_Start();	

	while(1)
	{
		width = TMA_GetPulseWidth();
		printf("P01/TAIO pulse width  = %d fCLK\n", width);  /* expected value: msCnt */
	}
#endif
	/*ʵʱ*/
	TMA_Get_PulsePeriod(TMA_FCLK_Div1, TMA_Pulse_Rising);
	TMA_Start();

	while(1)
	{
		width = TMA_GetPulsePeriod();

		printf("P01/TAIO pulse width  = %d fCLK\n", width);  /* expected value: msCnt */
	}
}

